=== mpm/include/mpm/ad9361/CMakeLists.txt ===
#
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0-or-later
#


INSTALL(FILES
    ad9361_ctrl.hpp
    e320_defaults.hpp
    DESTINATION ${INCLUDE_DIR}/mpm/catalina
)
