=== host/cmake/debian/control ===
Source: uhd
Section: science
Priority: optional
Maintainer: Ettus Research <packages@ettus.com>
Uploaders: Martin Braun <martin.braun@ettus.com>
Build-Depends:  debhelper (>= 9),
                cmake (>= 2.8.4+dfsg.1-3),
                python-dev,
                python-mako, 
                doxygen,
                libusb-1.0-0-dev [linux-any],
                libusb2-dev [kfreebsd-any],
                libncurses5-dev,
                pkg-config,
                libboost-dev,
                libboost-date-time-dev,
                libboost-filesystem-dev,
                libboost-program-options-dev,
                libboost-regex-dev,
                libboost-system-dev,
                libboost-thread-dev,
                libboost-test-dev,
                libboost-serialization-dev
Standards-Version: 3.9.7
Homepage: https://www.ettus.com
Vcs-Git: git://github.com/EttusResearch/uhd.git

Package: uhd-host
Architecture: any
Depends: libuhd003, python, adduser, python-requests, ${shlibs:Depends}, ${misc:Depends}
Recommends: python-tk, curl, procps
Suggests: gnuradio
Description: hardware driver for Ettus Research products
 Host utilities for the USRP Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package includes the uhd_find_devices application to locate and
 configure attached peripherals, and the uhd_usrp_probe application to
 display hardware configuration information.

Package: libuhd003
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: python, adduser, ${shlibs:Depends}, ${misc:Depends}
Suggests: gnuradio
Multi-Arch: same
Description: hardware driver for Ettus Research products
 Host library for the USRP Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.

Package: libuhd-dev
Architecture: any
Section: libdevel
Depends: libuhd003 (= ${binary:Version}), python, adduser, ${shlibs:Depends}, ${misc:Depends}
Suggests: libjs-jquery, gnuradio
Description: universal hardware driver for Ettus Research products
 Host library for the USRP Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package contains the header files and documentation for
 developing with libuhd.
